<?php
/* $id$ */

/**
 * @file
 * Polls a drupal server for queued calls and 
 * dispatches them to a asterisk server
 */

// this depends on your asterisk installation. what is below should work
$asterisk     = '/usr/local/sbin/asterisk';
$callspooldir = '/var/spool/asterisk/outgoing';
$tempdir      = '/tmp';
$sox          = '/usr/local/bin/sox';
$mpg123       = '/usr/local/bin/mpg123';
$debug        = TRUE; // TRUE might cause cron to send you a LOT of emails
$daemon       = 0; // time between runs, 0 to disable
$astconfdir   = '/usr/local/etc/asterisk';

// URL of the xmlrpc server to query for a call queue
$servers['1']['url']  = 'http://example.com/xmlrpc.php';
$servers['1']['name'] = 'john';
$servers['1']['pass'] = 'secretpassword';



// END OF CONFIGURATION //

chdir(dirname(__FILE__));
require_once('../../../includes/xmlrpc.inc');
require_once('../asterisk_common.inc');
require_once('support.inc');

$recorddir = $tempdir.DIRECTORY_SEPARATOR.'drupalrecord';
if (!is_dir($recorddir)) {
  mkdir($recorddir);
}

$confdir = $astconfdir.DIRECTORY_SEPARATOR.'drupal';
if (!is_dir($confdir)) {
  mkdir($confdir);
}


/*
 * This is the main loop
 */
do {
  $loop_start_time = time();

  $all_servers = array_merge($servers, asterisk_make_site_list($servers));
  if ($debug) {
    print_r($all_servers);
  }
  foreach ($all_servers as $server) {
    asterisk_call_queued($server);
    upload_recorded_messages($server, get_recorded_messages($server));
  }
  $sleep_time = $daemon - (time() - $loop_start_time);
  $sleep_time = $sleep_time > 0 ? $sleep_time : 0;
  print $sleep_time;
  sleep($sleep_time);
}
while ($daemon);

?>
